mod Ex07a

incl Mtex

incl Mtexrc

incl Mauxa

rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 9.11.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a univerzalnej funkcii pre p.r. funkcie. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 14.11.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  [CL] Remark.  \end Instead of the case discrimination function (see 
  the module \it  Mauxa  \end) use rather the `if-then-else function' \ft D \end 
  from the module \it  Standard  \end. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Recursion with Measure.  \end 

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Consider the following 
  regular recursive definition of the greatest common divisor function (in 
  clausal form): 

fun/2 Gcd_cl 'Tex_f2_n_gcd'
  Gcd_cl(x,y) = y <- x = 0
  Gcd_cl(x,y) = Gcd_cl(y mod x,x) <- x != 0

rem 
  \para Show that the function is primitive recursive with the help of its 
  approximation function. 

rem 
  \para \it  Solution.  \end Your task is divided into four steps as described 
  below. 

rem 
  \para \it  Step 1.  \end Find a suitable primitive recursive measure. 

fun/2 M_gcd 'Tex_f2_rec_rm_mu'
  M_gcd(x,y) = Foo

rem 
  \para \it  Step 2.  \end Transform the clausal definition into closed form 
  where every recursive application is guarded with the measure 
  \ft M_gcd(x,y) \end. Note that the result has a form of recursion with 
  measure. 

fun/2 Gcd_rm 'Tex_f2_n_gcd'
  Gcd_rm(x,y) = Foo

rem 
  \para \it  Step 3.  \end Construct the approximation function which 
  corresponds to the previous recursive definition with measure as a p.r. 
  function. 

fun/3 Af_gcd 'Tex_f3_rec_rm_af_f'
  Af_gcd(z,x,y) = Foo

rem 
  \para \it  Step 4.  \end Define \ft Gcd_cl(x,y) \end with the help of its 
  approximation function as a p.r. function. 

fun/2 Gcd_af 'Tex_f2_n_gcd'
  Gcd_af(x,y) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

