mod Ex07b logic: 'cl'

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Mauxb

incl Mxprf

rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 9.11.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a univerzalnej funkcii pre p.r. funkcie. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 4 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 14.11.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  [CL] Remark.  \end Catalan pairing function - see the module 
  \ft Mauxb \end. 

rem 
  \para \bf  [CL] Remark.  \end Clausal language is allowed. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion.  \end 

rem 
  \para \bf  Subsection. Universal Function for Primitive Recursive Functions is 
  not Primitive Recursive.  \end 

rem 
  \para \bf  Arithmetization of p.r. function symbols.  \end See also the module 
  \ft Mxprf \end. 

rem 
  \para \bf  N-tuples.  \end 

fun/3 Sel 'Tex_f3_pp_sel'
  Sel(n,x,i) = Foo

rem 
  \para \bf  Interpreter of p.r. function symbols.  \end \it  [Uloha (1 bod)] 
   \end 

fun/2 U 'Tex_f2_xpr_u'
  U(e,x) = Foo

rem 
  \para \bf  Primitive recursive indices.  \end See also the predicate 
  \ft Prf(e) \end holding of well-formed p.r. indices in the module 
  \ft Mxprf \end. 

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_1 'Tex_f0_xpr_xc1_1' \end Find a 
  p.r. index of the unary constant function \ft C1(x) = 1 \end, ie find the 
  number \ft Xc1_1 \end such that 
  \eq* 
    U(Xc1_1,x) = 1
  \end

fun/0 Xc1_1 'Tex_f0_xpr_xc1_1'
  Xc1_1 = Foo

thm Spec_xc1
  U(Xc1_1,x) = 1

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_2 'Tex_f0_xpr_xc1_2' \end Find a 
  p.r. index of the unary constant function \ft C2(x) = 2 \end, ie find the 
  number \ft Xc1_2 \end such that 
  \eq* 
    U(Xc1_2,x) = 2
  \end

fun/0 Xc1_2 'Tex_f0_xpr_xc1_2'
  Xc1_2 = Foo

thm Spec_xc1_2
  U(Xc1_2,x) = 2

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_3 'Tex_f0_xpr_xc1_3' \end Find a 
  p.r. index of the unary constant function \ft C3(x) = 3 \end, ie find the 
  number \ft Xc1_3 \end such that 
  \eq* 
    U(Xc1_3,x) = 3
  \end

fun/0 Xc1_3 'Tex_f0_xpr_xc1_3'
  Xc1_3 = Foo

thm Spec_xc1_3
  U(Xc1_3,x) = 3

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/0 Xplus 'Tex_f0_xpr_xplus' \end Find a p.r. index of the addition 
  function \ft x+y \end, ie find the number \ft Xplus \end such that 
  \eq* 
    U(Xplus,x,y) = x+y
  \end

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

thm Spec_xplus
  U(Xplus,x,y) = x+y

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xtimes 'Tex_f0_xpr_xtimes' \end Find 
  a p.r. index of the multiplication function \ft x*y \end, ie ie find the 
  number \ft Xtimes \end such that 
  \eq* 
    U(Xtimes,x,y) = x*y
  \end

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

thm Spec_xtimes
  U(Xtimes,x,y) = x*y

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/0 Xexp 'Tex_f0_xpr_xexp' \end Find a p.r. index of the 
  exponentiation function \ft Exp(x,y) \end, ie find the number \ft Xexp \end 
  such that 
  \eq* 
    U(Xexp,x,y) = Exp(x,y)
  \end

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

thm Spec_xexp
  U(Xexp,x,y) = Exp(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_27 'Tex_f0_xpr_xc1_27' \end Find 
  a p.r. index of the unary constant function \ft C27(x) = 27 \end, ie find the 
  number \ft Xc1_27 \end such that 
  \eq* 
    U(Xc1_27,x) = 27
  \end

fun/0 Xc1_27 'Tex_f0_xpr_xc1_27'
  Xc1_27 = Foo

thm Spec_xc1_27
  U(Xc1_27,x) = 27

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xpred 'Tex_f0_xpr_xpred' \end Find a 
  p.r. index of the predecessor function \ft x-1 \end, ie find the number 
  \ft Xpred \end such that 
  \eq* 
    U(Xpred,x) = x-1
  \end

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

thm Spec_xpred
  U(Xpred,x) = x-1

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/0 Xminus 'Tex_f0_xpr_xminus' \end Find a p.r. index of the 
  modified subtraction function \ft x-y \end, ie find the number \ft Xminus \end 
  such that 
  \eq* 
    U(Xminus,x,y) = x-y
  \end

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

thm Spec_xminus
  U(Xminus,x,y) = x-y

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

